## SugarCube Funge Interpreter Plugin with PyFunge 0.2
##
## Author  : Kang Seonghoon <zenith@tokigun.net>
## Created : June 5, 2004
## Updated : $Date: 2004/06/10 16:05:21 $
##
## $Id: handler.py,v 1.2 2004/06/10 16:05:21 tokigun Exp $

__api__ = 'SUGARCUBEv2'
__maxsteps__ = 30000

import PyFunge.execute
import sys
from PyFunge.exception import *
from PyFunge.platform import FungePlatform

### for debugging... :p
##reload(PyFunge.execute)

class FungePlatform_sugarcube(FungePlatform):
	def __init__(self, ev):
		FungePlatform.__init__(self)
		self.ev = ev
		self.putbuffer = ''
	
	def getchar(self):
		raise RuntimeError, "This plugin doesn't allow input instruction."
	def putchar(self, char):
		self.putbuffer += chr(char)
		if self.putbuffer[-1] == '\n':
			self.ev.reply(self.putbuffer[:-1])
			self.putbuffer = ''
	
	def _getline(self):
		raise RuntimeError, "This plugin doesn't allow input instruction."
	def _getchar(self):
		raise RuntimeError, "This plugin doesn't allow input instruction."
	
	def getint(self):
		raise RuntimeError, "This plugin doesn't allow input instruction."

def fungecmd(ev, mode=False):
	if len(ev.args) < 1:
		ev.reply(ev._("\2PyFunge plugin for SugarCube, by Kang Seonghoon (Tokigun)\2"))
		ev.reply(ev._("Usage : -funge {one-line Befunge-98 code}"))
		ev.reply(ev._("Automatically stopped when %d instructions are executed.") % (__maxsteps__,))
	else:
		code = ev.rawargs
		platform = FungePlatform_sugarcube(ev)
#		execute = PyFunge.execute.FungeExec_Befunge93(platform)
		execute = PyFunge.execute.FungeExec_Befunge98(platform)
#		execute = PyFunge.execute.FungeExec_Unefunge98(platform)
		res = ""
		stopped = False
		
		try:
			execute.space.putspace((0,) * execute.dimension, code)
		except:
			res = ev._("Error on PyFunge.space.putspace: Code doesn't fit in Befunge-space!")
		
		if not res:
			for x in xrange(__maxsteps__):
##				if mode:
##					print execute.getcell(), execute.position, execute.delta,
##					for x in xrange(execute.stack.slen()):
##						print execute.stack.stack[x].stack,
##					print ""
				try:
					execute.onestep()
				except (ExecQuitError, ExecStopError):
					stopped = True
					break
				except:
					exc = sys.exc_info()
					raise
					res = "\2Error on PyFunge.execute.onestep\2: %s (%s)" % (str(exc[0]), str(exc[1]))
					break
			
			if execute.stack.slen() > 1:
				message = \
					"%d item(s) in topmost stack, %d stacks in stack stack" % \
					(execute.stack.len(), execute.stack.slen())
			else:
				message = "%d item(s) in stack" % (execute.stack.len(),)
			
			if stopped:
				for ch in "\37\2[Stopped:\2 %d steps, %s\2]\2\37\n" % (x+1, message):
					execute.platform.putchar(ord(ch))
			elif not res:
				execute.platform.putchar(10)
				res = "\37\2[Not Stopped:\2 more than %d steps, %s\2]\2\37" % \
					(__maxsteps__, message)

		if res:
			ev.reply(res)

##def _fungecmd(ev):
##	return fungecmd(ev, True)

__commands__ = {
	"funge": (fungecmd, 'N'),
##	"xfunge": (_fungecmd, 'N'),
}
